<template>
  <div class="aspect-[3/4] v-game-entry relative group">
    <div class="v-game-entry__background v-game-entry__transition">
      <img
        v-if="bgImage && bgImage.length > 0"
        :src="bgImage"
        loading="lazy"
        class="w-full"
        @error="
          (e) =>
            isHandleDefaultImageRender(bgImage)
              ? onErrorDefaultImage(e, bgImage)
              : e.target.remove()
        "
      />
      <img
        v-else
        :src="
          getAssetImage('assets/theme/common/entry/live_casino/background.png')
        "
        loading="lazy"
        class="w-full"
        @error="(e) => e.target.remove()"
      />
    </div>
    <img
      :src="getAssetImage('assets/theme/common/entry/casino_02.png')"
      class="absolute top-0 left-0 w-full"
    />
    <div v-if="isNew || isHot" class="v-game-entry__tags gap-1">
      <img
        v-if="isNew"
        class="v-game-entry__tag"
        :src="getAssetImage('assets/theme/common/icon/new_icon.svg')"
      />
      <img
        v-if="isHot"
        class="v-game-entry__tag"
        :src="getAssetImage('assets/theme/common/icon/hot_icon.svg')"
      />
    </div>
    <div class="absolute top-0 left-0 w-full h-full card-casino">
      <div class="relative flex flex-col justify-between w-full h-full">
        <div class="w-full mt-[4%]">
          <img
            v-if="
              isFloatBackgroundEntry && floatBgImage && floatBgImage.length > 0
            "
            :src="floatBgImage"
            loading="lazy"
            class="max-w-[85%] mt-[19%] absolute top-0 left-1/2 -translate-x-1/2 object-contain v-game-entry__transition v-game-entry__floating-bg"
            @error="
              (e) =>
                isHandleDefaultImageRender(floatBgImage)
                  ? onErrorDefaultImage(e, floatBgImage)
                  : e.target.remove()
            "
          />

          <div class="w-full">
            <img
              v-if="personImage && personImage.length > 0"
              :src="personImage"
              loading="lazy"
              class="object-contain w-full v-game-entry__person v-game-entry__transition bottom_blur"
              @error="
                (e) =>
                  isHandleDefaultImageRender(personImage)
                    ? onErrorDefaultImage(e, personImage)
                    : e.target.remove()
              "
            />
          </div>
        </div>
        <div
          class="absolute left-0 flex flex-col items-center justify-center w-full gap-2 bottom-2"
        >
          <img
            v-if="logoImage && logoImage.length > 0"
            :src="logoImage"
            loading="lazy"
            class="max-w-[120px] translate-y-3 v-game-entry__logo v-game-entry__transition"
            @error="(e) => e.target.remove()"
          />
          <sport-blue-tag
            v-if="tag && tag.length > 0"
            class="mb-2 v-game-entry__blue-tag v-game-entry__transition"
            style="--blue-tag-text-size: 0.75rem"
          >
            {{ tag }}
          </sport-blue-tag>

          <p v-if="label && label.length > 0" class="v-game-entry__title">
            {{ label }}
          </p>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import commonHelper from "@/utils/commonHelper";

export default defineComponent({
  props: {
    bgImage: {
      type: String,
      required: false,
    },
    logoImage: {
      type: String,
      required: false,
    },
    floatBgImage: {
      type: String,
      required: false,
    },
    personImage: {
      type: String,
      required: false,
    },
    label: {
      type: String,
      required: false,
    },
    isNew: {
      type: Boolean,
      required: false,
      default: false,
    },
    isHot: {
      type: Boolean,
      required: false,
      default: false,
    },
    tag: {
      type: String,
      required: false,
    },
  },
  setup() {
    const {
      getAssetImage,
      onErrorDefaultImage,
      isHandleDefaultImageRender,
      isFloatBackgroundEntry,
    } = commonHelper;
    return {
      getAssetImage,
      onErrorDefaultImage,
      isHandleDefaultImageRender,
      isFloatBackgroundEntry,
    };
  },
});
</script>

<style>
:root {
  --v-game-entry-color: var(--background1);
  --v-game-entry-width: 18rem; /* 288px */
  --v-game-entry-radius: 0.5rem; /* 8px */

  --v-game-entry-tag-position: flex-start; /* flex-start | center | flex-end */
  --v-game-entry-tag-width: 0.25; /* 80px */

  --v-game-entry-label-color: #fff;
  --v-game-entry-label-weight: 700; /* 100 | 200 | 300 | 400 | 500 | 600 | 700 | 800 | 900 | bold | bolder | lighter |normal | inherit | initial | unset */
  --v-game-entry-label-size: 1rem; /* 18px */

  --v-game-entry-duration: 700ms;
  --v-game-entry-transform-origin: bottom center;

  --v-game-entry-floating-bg-scale: 1.16;
  --v-game-entry-floating-bg-transform-origin: var(
    --v-game-entry-transform-origin
  );
  --v-game-entry-floating-bg-translate-y: -3rem;

  --v-game-entry-person-scale: 1.11;
  --v-game-entry-person-transform-origin: var(--v-game-entry-transform-origin);

  --v-game-entry-logo-scale: 1.7;
  --v-game-entry-logo-transform-origin: var(--v-game-entry-transform-origin);
}
</style>

<style scoped lang="scss">
.bottom_blur {
  -webkit-mask-image: linear-gradient(to bottom, black 93%, transparent 100%);
  mask-image: linear-gradient(to bottom, black 93%, transparent 100%);
}
.group:hover {
  .v-game-entry {
    &__background {
      opacity: 1;
    }
    &__blue-tag {
      --tw-scale-x: 1.29;
      --tw-scale-y: 1.29;
      transform: translate(var(--tw-translate-x), var(--tw-translate-y))
        rotate(var(--tw-rotate)) skewX(var(--tw-skew-x)) skewY(var(--tw-skew-y))
        scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));
    }

    &__floating-bg {
      --tw-scale-x: var(--v-game-entry-floating-bg-scale);
      --tw-scale-y: var(--v-game-entry-floating-bg-scale);
      --tw-translate-y: var(--v-game-entry-floating-bg-translate-y);
      transform: translate(var(--tw-translate-x), var(--tw-translate-y))
        rotate(var(--tw-rotate)) skewX(var(--tw-skew-x)) skewY(var(--tw-skew-y))
        scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));
    }

    &__person {
      --tw-scale-x: var(--v-game-entry-person-scale);
      --tw-scale-y: var(--v-game-entry-person-scale);
      transform: translate(var(--tw-translate-x), var(--tw-translate-y))
        rotate(var(--tw-rotate)) skewX(var(--tw-skew-x)) skewY(var(--tw-skew-y))
        scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));
    }

    &__logo {
      --tw-scale-x: var(--v-game-entry-logo-scale);
      --tw-scale-y: var(--v-game-entry-logo-scale);
      transform: translate(var(--tw-translate-x), var(--tw-translate-y))
        rotate(var(--tw-rotate)) skewX(var(--tw-skew-x)) skewY(var(--tw-skew-y))
        scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));
    }
  }
}
.v-game-entry {
  background-color: var(--background5);
  width: var(--v-game-entry-width);
  border-radius: var(--v-game-entry-radius);

  &__person {
    transform-origin: var(--v-game-entry-person-transform-origin);
  }

  &__logo {
    transform-origin: var(--v-game-entry-logo-transform-origin);
  }

  &__transition {
    transition-property: all;
    transition-timing-function: cubic-bezier(0.4, 0, 0.2, 1);
    transition-duration: var(--v-game-entry-duration);
  }

  &__floating-bg {
    transform-origin: var(--v-game-entry-floating-bg-transform-origin);
  }

  &__background {
    position: relative;
    width: 100%;
    overflow: hidden;
    background: linear-gradient(
      180deg,
      rgba(0, 0, 0, 0) 0%,
      rgba(0, 0, 0, 0.4) 100%
    );
    opacity: 0;
    border-radius: var(--v-game-entry-radius);

    // darken lower background
    &::after {
      content: "";
      position: absolute;
      width: 100%;
      height: 100%;
      top: 0;
      left: 0;
      background: linear-gradient(
        180deg,
        rgba(0, 0, 0, 0) 0%,
        rgba(0, 0, 0, 0.4) 100%
      );
    }
  }

  &__tag {
    width: calc(100% * var(--v-game-entry-tag-width));

    &s {
      width: 100%;
      position: absolute;
      top: calc(100% * 0.02);
      left: calc(100% * 0.02);
      z-index: 2;
      display: flex;
      flex-direction: column;
      align-items: var(--v-game-entry-tag-position);
      // padding: 0.5rem;
    }
  }

  &__title {
    color: var(--v-game-entry-label-color);
    font-weight: var(--v-game-entry-label-weight);
    font-size: var(--v-game-entry-label-size);
    padding-left: 0.5rem;
    padding-right: 0.5rem;
    margin-top: 0.5rem;
  }
}
</style>
